#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> treeValues(n);
    for (int i = 0; i < n; i++) {
        cin >> treeValues[i];
    }

    vector<int> originalArray(n, -1);

    for (int i = 0; i < n; i++) {
        int idx = 0;
        while (originalArray[idx] != -1) {
            if (treeValues[i] < originalArray[idx]) {
                idx = 2 * idx + 1;
            } else {
                idx = 2 * idx + 2;
            }
        }
        originalArray[idx] = treeValues[i];
    }

    // Проверка, можно ли восстановить дерево
    for (int i = 0; i < n; i++) {
        if (originalArray[i] == -1) {
            cout << -1 << endl;
            return 0;
        }
    }

    for (int i = 0; i < n; i++) {
        cout << originalArray[i] << " ";
    }
    cout << endl;

    return 0;
}